> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/nemo-platform/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.nvidia.com/nemo-platform/_mcp/server.

# Update workspace member roles

PUT /apis/entities/v2/workspaces/{workspace}/members/{principal_id}
Content-Type: application/json

Update the roles for a workspace member.

This will revoke existing roles not in the new list and add new roles.
By default, this endpoint waits for the roles to propagate before returning.
Use `wait_role_propagation=false` to skip waiting (useful for bulk operations).

Example:

```
PUT /apis/entities/v2/workspaces/ml-team/members/user@example.com
{
    "roles": ["Viewer", "Editor"]
}
```

Reference: https://docs.nvidia.com/nemo-platform/nemo-platform/v0.3.0/documentation/reference/api-reference/entity-store/update-workspace-member-apis-entities-v-2-workspaces-workspace-members-principal-id-put

## Request

### Path parameters

- `workspace` (string, required)
- `principal_id` (string, required)

### Query parameters

- `wait_role_propagation` (boolean, optional, default: true) — If true, wait for roles to propagate before returning (default: true). Set to false for bulk operations.

### Body (application/json)

- `roles` (list of string, required) — Updated list of roles for the principal

## Response

### 200

Successful Response

- `principal` (string, required) — The principal identifier
- `roles` (list of string, required) — List of roles granted to the principal
- `granted_at` (datetime, optional) — Earliest date when a role was granted to this principal
- `granted_by` (string, optional) — Who granted the earliest role

## Examples

**Request**

```json
{
  "roles": [
    "Viewer"
  ]
}
```

**Response**

```json
{
  "principal": "string",
  "roles": [
    "string"
  ],
  "granted_at": "2024-01-15T09:30:00Z",
  "granted_by": "string"
}
```

**SDK Code**

```python
import requests

url = "https://api.example.com/apis/entities/v2/workspaces/workspace/members/principal_id"

payload = { "roles": ["Viewer"] }
headers = {"Content-Type": "application/json"}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.example.com/apis/entities/v2/workspaces/workspace/members/principal_id';
const options = {
  method: 'PUT',
  headers: {'Content-Type': 'application/json'},
  body: '{"roles":["Viewer"]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.example.com/apis/entities/v2/workspaces/workspace/members/principal_id"

	payload := strings.NewReader("{\n  \"roles\": [\n    \"Viewer\"\n  ]\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.example.com/apis/entities/v2/workspaces/workspace/members/principal_id")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Content-Type"] = 'application/json'
request.body = "{\n  \"roles\": [\n    \"Viewer\"\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://api.example.com/apis/entities/v2/workspaces/workspace/members/principal_id")
  .header("Content-Type", "application/json")
  .body("{\n  \"roles\": [\n    \"Viewer\"\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://api.example.com/apis/entities/v2/workspaces/workspace/members/principal_id', [
  'body' => '{
  "roles": [
    "Viewer"
  ]
}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.example.com/apis/entities/v2/workspaces/workspace/members/principal_id");
var request = new RestRequest(Method.PUT);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"roles\": [\n    \"Viewer\"\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = ["roles": ["Viewer"]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.example.com/apis/entities/v2/workspaces/workspace/members/principal_id")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```